/*     bru2new.c Convert bru to new brl/htm format xxx
(c) 2022 Duxbury Systems, Inc
Written by David Holladay 
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <io.h>

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <io.h>


FILE *fi,*fo;
char linep[5000],dos[100],name[100];
int c,c2,c3, j,k,l,nx,num,spc,toc,typ,pt,table,allmark;
char *p1,*p2,*p2x,*p3,*p4,*p1x,*p1o;

void main(int argc,char *argv[])
{
	if (strstr(argv[argc-1],"?"))
	{
		if (!strstr(argv[argc-1],"??")) printf("\nConvert new brl/htm to bru format\n\n");
		return;
	}
	if (argc>2)
	{
		if (!argv[2])
		{
			printf("\nNull output file name.\n");
			return;
		}
		if ((fi=fopen(argv[1],"rt"))==NULL)
		{
			printf("\nCannot open input bru file: %s\n",argv[1]);
			return;
		}
		if ((fo=fopen("zq67.txt","wt"))==NULL)
		{
			printf("\nCannot open temp output file: zq67.txt\n");
			return;
		}
		if (argc>3)
		{
			if (strstr(argv[3],"all")) 
			{
				allmark=1;
				printf("all markup mode.\n");
			}
		}
	}
	printf("bru2new version 2.0\n");
	pt=0,linep[0]=0;
	while ((c=fgetc(fi))!=EOF)
	{
		if (c!=10) linep[pt]=c,linep[pt+1]=0,linep[pt+2]=0,linep[pt+3]=0,pt++;
		else
		{
			j=0;
			while (linep[j])
			{
				if ((linep[j]=='.')&&(linep[j+1]<0)) j=j+2,linep[j]='_';
				c=linep[j];
				if (c==26) j++;
				if (!strncmp(linep+j,"|es~",4)&&strncmp(linep+j,"|es~compinline",12)) {fprintf(fo," \n"); /*printf("\n");*/} //qqq
				if (!strcmp(linep+j,"|l")) {j=j+2;} 
				else if (!strncmp(linep+j,"|l |es~hl1.",11)) {fprintf(fo,"\n|l |es~hl1."); j=j+11;}
				else if (!strncmp(linep+j,"|es~hl1.",8)) {fprintf(fo,"|l |es~hl1."); j=j+8;} 
				else fprintf(fo,"%c",c);
				j++;
			}
			fprintf(fo," ");
			pt=0;	
		}
	}
	fprintf(fo,"\n\n");
	fclose(fi);
	fclose(fo);
	if ((fi=fopen("zq67.txt","rt"))==NULL)
	{
		printf("cannot open temp file.\n");
		return;
	}
	fo=fopen("zq69.txt","wt");

	pt=0;
	while ((c=fgetc(fi))!=EOF)
	{	
		if (c!=10) linep[pt]=c,linep[pt+1]=0,linep[pt+2]=0,linep[pt+3]=0,pt++;
		else 
		{
			if (table) fprintf(fo,"\n<tr><td>");
			j=0;
			while (linep[j])
			{
				c=linep[j];
				if (table&&(c=='|')&&(linep[j+1]=='>')) {j=j+2; fprintf(fo,"</td><td>");}
				else if (c!='|') {j++; fprintf(fo,"%c",c);}
				else
				{
					//printf("qq: %c%c%c%s\n",linep[j+2],linep[j+3],linep[j+4],linep); //qqq
					if ((linep[j+1]=='e')&&((linep[j+2]=='s')||(linep[j+2]=='e'))&&(linep[j+3]=='~'))
					{
						// if | with ee or es
						typ=(linep[j+2]=='s');
						k=j+4,l=0;
						while (linep[k]&&(linep[k]!=' ')&&(linep[k]!='`')) {name[l]=linep[k],name[l+1]=0,k++,l++;}
						nx=name[strlen(name)-1];
						if (nx=='.') // with . at end of style name 
						{
							name[strlen(name)-1]=0;
							if (strstr("tp.title",name)) strcpy(name,"title");
							if (strstr("para",name)) strcpy(name,"p para");
							if (typ) fprintf(fo,"\n");
						}					
						if (strstr(name,"htbe")) {strcpy(name,"/table"); table=0;}
						if (strstr("body",name)) fprintf(fo,"\n");
						if (strstr("ol",name)) fprintf(fo,"\n");
						if (strstr("ul",name)) fprintf(fo,"\n");
						if (strstr("li",name)) fprintf(fo,"\n");
						if (typ&&strstr("a",name)) 
						{
							p2=strstr(linep+j,"|es~a \"<"),p2x=strstr(linep+j,"|es~a \">");
							p4=strstr(linep+j,"|ee~a"),p1x=strstr(linep+j+7,"\">"),p1=strstr(linep+j,"\"<");
							if (p2) // after es~a there is (
							{
								if (p1x) p1=p1x;
								if (p4) *p4=0;
								if (p1&&p2) j=j+8,*p1=0,*p2=0,p1=p1+2,p2=p2+8,k=p4-(linep)+4,typ=0;
							}
							else if (p2x) // after es~a there is )
							{
								p2=p2x;
								if (p1x) p1=p1x;
								else p1=p2+7;
								if (p4) p2=p4;
								else p2=linep+strlen(linep)-10;
								if (p1&&p2) j=j+8,*p1=0,*p2=0,p1=p1+2,p2=p2+8,k=p2-(linep)+6,typ=0;
							}
							else if (p1) // normal, no paren
							{
								p2=strstr(p1+1,"4"), p3=strstr(p1+1,"\">"),p4=strstr(p1+1,"|ee~a");
								//no period in filename, advance to next open paren
								p2=strstr(p1+1,"4"), p3=strstr(p1+1,"\">");
								if (p2&&p3&&p4&&(p2>p3)&&(p3<p4)) p1=p3+3;
								p2=strstr(p1+1,"\">");
								if (!p2) p2=linep+strlen(linep)-10;
								if (!p1)
								{
									strcpy(p1,"nolink");
									j=j+4;
								}
								else
								{
									j=j+6,*p1=0,*p2=0,p1=p1+2;
								}
								num=0,spc=1,p1o=p1;
								k=p2-(linep)+6,typ=0;
							}
							// else printf("no p1** &s\n",linep);
							if (p1&&p2)
							{
								num=0,spc=1,p1o=p1;
								fprintf(fo,"<a href=\"");
								while (*p1)
								{
									//replacement for half-baked back translator
									c=*p1,c2=*(p1+1),c3=*(p1+2);
									fprintf(fo,"%c",c);
									p1++;
								}
								fprintf(fo,"\">%s",linep+j);
							}
						}
						if (typ) fprintf(fo,"<%s>",name);
						else fprintf(fo,"</%s>",name);
						j=k+1;
					}
					else if (!strncmp(linep+j,"|htbs",5))
					{
						fprintf(fo,"\n<table>"); 
						while (linep[j]!=' ') j++;
						table=1;
					}
					else if (!strncmp(linep+j,"|htbe",5))
					{
						fprintf(fo,"\n</table>"); 
						while (linep[j]!=' ') j++;
						table=0;
					}
					else if (!strncmp(linep+j,"|hl",3))
					{
						fprintf(fo,"\n<toc%c>",linep[j+3]); 
						j=j+5;
					}
					else if (!strncmp(linep+j,"|fr ",4))
					{
						fprintf(fo,"<pg>"); 
						j=j+3;
					}
					else if (!strncmp(linep+j,"|fr",3))
					{
						fprintf(fo,"<pg-num>"); 
						j=j+8;
					}
					else if (!strncmp(linep+j,"|-",2))
					{
						fprintf(fo,"<|->");
						j=j+2;
					}
					else if (!strncmp(linep+j,"|l |hl1",7))
					{
						fprintf(fo,"\n<li>");
						j=j+7;
					}
					else if (!strncmp(linep+j,"|l |hl2",7))
					{
						fprintf(fo,"\n<li 2>");
						j=j+7;
					}
					else if (!strncmp(linep+j,"|l |hl3",7))
					{
						fprintf(fo,"\n<li 3>");
						j=j+7;
					}
					else if (!strncmp(linep+j,"|l |hl4",7))
					{
						fprintf(fo,"\n<li 4>");
						j=j+7;
					}
					else if (!strncmp(linep+j,"|hl1",4))
					{
						fprintf(fo,"\n<li>");
						j=j+4;
					}
					else if (!strncmp(linep+j,"|hl2",4))
					{
						fprintf(fo,"\n<li 2>");
						j=j+4;
					}
					else if (!strncmp(linep+j,"|hl3",4))
					{
						fprintf(fo,"\n<li 3>");
						j=j+4;
					}
					else if (!strncmp(linep+j,"|hl4",4))
					{
						fprintf(fo,"\n<li 4>");
						j=j+4;
					}
					else if (!strncmp(linep+j,"|'",2))
					{
						fprintf(fo,"<|'>");
						j=j+2;
					}
					else if (!strncmp(linep+j,"|l`",3))
					{
						fprintf(fo,"<p l>");
						j=j+3;
					}
					else if (!strncmp(linep+j,"|l",2))
					{
						fprintf(fo,"<p l>");
						j=j+2;
					}
					else if (linep[j+1]!='<')
					{
						k=j+1,l=0;
						while (linep[k]&&(linep[k]!=' ')&&(linep[k]!='`')) {name[l]=linep[k],name[l+1]=0,k++,l++;}
						fprintf(fo,"<|%s>",name);
						j=k+0;
					}
					else // |< new line
					{
						strcpy(name,"p lt");
						fprintf(fo,"\n<%s>",name);
						j=j+2;
					}
				}
			}
			fprintf(fo," ");
			pt=0,linep[0]=0;
		}
	}
	fprintf(fo,"\n");
	fclose(fi);
	fclose(fo);
	if ((fo=fopen("zq69.txt","rt"))==NULL)
	{
		printf("\nCannot open temp output file: zq69.txt\n");
		return;
	}
	fo=fopen(argv[2],"wt");
	strcpy(dos,"<zrshark99>");
	pt=0;
	while ((c=fgetc(fi))!=EOF)
	{
		if (c!=10) linep[pt]=c,linep[pt+1]=0,linep[pt+2]=0,linep[pt+3]=0,pt++;
		else
		{
			j=0,k=0;
			if ((linep[0]=='<')&&strstr(linep,">"))
			{
				k=1;
				while (linep[j]!='>')
				{
					if (k&&(linep[j]==dos[j])) j++;
					else k=0,dos[j]=linep[j],dos[j+1]='>',dos[j+2]=0,j++;
				}
			}
			if (!k||allmark) j=0;
			else j++;
			fprintf(fo,"%s\n",linep+j);
			pt=0,linep[0]=0;
		}
	}
	fprintf(fo,"\n");
	fclose(fi);
	fclose(fo);
	sprintf(dos,"del zq6*.txt\n");
	system(dos);
}
